<?php

require_once 'base/GepFluxoEntityBase.php';

/**
 * GepFluxoEntity.
 *
 * @package Entity
 * @author  daniellepereira <username@example.com>
 */
class GepFluxoEntity extends GepFluxoEntityBase
{


    const SEM_REGISTRO = '10';


    /**     ok
     * Retorna dados de uma situacao.
     *
     * @param integer $nrorg     Numero da Organizacao.
     * @param integer $situacao  Numero da situacao.
     * @param integer $tipo_soli Tipo de solicitacao.
     *
     * @return Ambigous <boolean, multitype:, NULL, TkModelEntity>
     */
    public function retornaFluxoSituacao($nrorg, $situacao, $tipo_soli){
        $consulta = GepFluxo::consultaFluxosSituacao($nrorg, $situacao, $tipo_soli);
        return $consulta;
    }


    /**        ok
     * Retorna dados de um fluxo.
     *
     * @param integer $nrorg Numero da organizacao.
     * @param integer $fluxo Numero do fluxo.
     *
     * @return Ambigous <boolean, mixed, NULL>
     */
    public function retornaFluxo($nrorg, $fluxo){
        $consulta = GepFluxo::consultaFluxo($nrorg, $fluxo);
        return $consulta;
    }


    /**
    * Gera novo c?o de Fluxo de um Tipo de fluxo, Tipo de Solicita? e Situa?.
    *
    * @param integer $nrorg N?o da Organiza?.
    *
    * @return $codigo integer
    */
    public static function retornaProxNumeroFluxo($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_FLUXO', 10);
        return $codigo;
    }


    /**
     * Retorna a consulta de fluxos de encaminhamento.
     *
     * @return string
     */
    public static function retornaQueryFluxo(){
        $consulta = GepFluxo::consultaQueryFluxo();
        return $consulta;
    }

}