<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\DateUtil;
use HCM\Util\Repositories;

class FpaItecalcfolha extends \Doctrine\ORM\EntityRepository {
    
    public function retornaItemPeriodo($nrorg, $nr_vinculo, $lista_nr_calculo, $lista_nr_evento){
      
        $lista_nr_evento = preg_split('/[\s,]+/', $lista_nr_evento);
        $lista_nr_calculo = preg_split('/[\s,]+/', $lista_nr_calculo);
        
        $params = array('nrorg'=>$nrorg, 'nrvinculom'=>$nr_vinculo, 'nreventom'=>$lista_nr_evento, 'nrcalculofolha'=>$lista_nr_calculo);
        $fpaIteCalcFolha = Repositories::FPA_ITECALCFOLHA;
        
$sql = <<<SQL
    SELECT i FROM $fpaIteCalcFolha i
    WHERE        
    i.nreventom IN (:nreventom)
    AND i.nrcalculofolha IN (:nrcalculofolha)
    AND i.nrvinculom = :nrvinculom
    AND i.nrorg = :nrorg
    ORDER BY i.nreventom, i.dtocorrencia DESC
SQL;
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        
        return $result;
    }
    
    public static function retornaTotalIncidCalculoPorEstrut($nrorg, $nrcalculofolha, $nrtipoincide, $nrestrutlegal, $nrestrutgeren, $dtmescompetenc)
    {

    
        $sql = <<<SQL
SELECT SUM(DECODE(IE.IDINCIDEVENTO,'+',IC.VREVENTOFOLHA,'-',IC.VREVENTOFOLHA*-1,0)) VRTOTAL
  FROM FPA_ITECALCFOLHA IC
  JOIN FPA_INCIDEVENTO IE ON (IE.NRORG = IC.NRORG OR IE.NRORG = 0)
                         AND IE.NREVENTOM = IC.NREVENTOM
                         AND IE.NRTIPOINCIDE = :P_NRTIPOINCIDE
  JOIN GPE_VINCULOH VH ON VH.NRORG = IC.NRORG
                      AND VH.NRVINCULOM = IC.NRVINCULOM
                      AND (VH.NRESTRUTLEGAL = :P_NRESTRUTLEGAL OR :P_NRESTRUTLEGAL = 'A')
                      AND (VH.NRESTRUTGEREN = :P_NRESTRUTGEREN OR :P_NRESTRUTGEREN = 'A')
                      AND VH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRORG = VH.NRORG
                                                  AND H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
 WHERE IC.NRORG = :P_NRORG
   AND IC.NRCALCULOFOLHA = :P_NRCALCULOFOLHA
SQL;
        $param = array(
            'P_NRORG'          => $nrorg,
            'P_NRCALCULOFOLHA' => $nrcalculofolha,
            'P_NRTIPOINCIDE'   => $nrtipoincide,
            'P_NRESTRUTLEGAL'  => $nrestrutlegal,
            'P_NRESTRUTGEREN'  => $nrestrutgeren,
            'P_DTMESCOMPETENC' => $dtmescompetenc);
        $result = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $param);
        return empty($result) ? 0 : $result[0]['VRTOTAL'];
    }
    
    public function getValorEvento($nrcalculofolha,$nrvinculom, $nrorg, $nreventom, $dtpagamento){
      
        $params = array('nrorg'=>$nrorg, 'nrvinculom'=>$nrvinculom, 'nreventom'=>$nreventom, 'nrcalculofolha'=>$nrcalculofolha,
        'dtocorrencia' => $dtpagamento);
        
        $fpaIteCalcFolha = Repositories::FPA_ITECALCFOLHA;
        
$sql = <<<SQL
    SELECT i.vreventofolha FROM $fpaIteCalcFolha i
    WHERE        
    i.nreventom = :nreventom
    AND i.nrcalculofolha = :nrcalculofolha
    AND i.nrvinculom = :nrvinculom
    AND i.nrorg = :nrorg
    AND i.dtocorrencia >= :dtocorrencia
SQL;
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        
        if($result){
            return $result[0]['vreventofolha'];
        }
        
        return null;
    }
    
    public function getItemCalculoEventoS1210($nrorg, $nrvinculom, $nreventom, $dtmescompetenc, $nrtipomoviment, $nrtpmodalidcal, $dtocorrencia){
        
        $params = array(
            'nrorg'=>$nrorg, 
            'nrvinculom'=>$nrvinculom, 
            'nreventom'=>$nreventom, 
            'dtmescompetenc'=>$dtmescompetenc,
            'nrtpmodalidcal'=>$nrtpmodalidcal, 
            'dtocorrencia_ini'=>DateUtil::getDataDeString($dtocorrencia, DateUtil::FORMATO_BRASILEIRO_DATAHORA)->format('01/m/Y'), 
            'dtocorrencia_fim'=>DateUtil::getDataDeString($dtocorrencia, DateUtil::FORMATO_BRASILEIRO_DATAHORA)->format('t/m/Y')
        );
        
        $fpaIteCalcFolha = Repositories::FPA_ITECALCFOLHA;
        $fpaCalculoFolha = Repositories::FPA_CALCULOFOLHA;
        
$sql = <<<SQL
    SELECT i
    FROM $fpaIteCalcFolha i
    JOIN $fpaCalculoFolha c WITH c.nrorg = i.nrorg
                             AND c.nrcalculofolha = i.nrcalculofolha
                             AND c.nrtpmodalidcal = :nrtpmodalidcal
                             AND c.dtocorrencia = :dtmescompetenc
    WHERE i.nrorg = :nrorg
    AND i.nrvinculom = :nrvinculom
    AND i.nreventom = :nreventom
    AND i.dtocorrencia between :dtocorrencia_ini and :dtocorrencia_fim
SQL;
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        
        return current($result);
    }
    
    
}